using System;
using System.Collections.Generic;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

using XnaChatSample.UI;
using XnaChatSample.Util;

namespace XnaChatSample
{
    public class Game1 : Microsoft.Xna.Framework.Game
    {
        GraphicsDeviceManager graphics;
        SpriteBatch spriteBatch;

        // f
        private Model box;
        private Vector3 pos;
        private Vector3 rot; 
        
        FormManager formMgr = null;
        public Game1()
        {
            graphics = new GraphicsDeviceManager(this);
            formMgr = new FormManager(this, graphics);

            Content.RootDirectory = "Content";
            IsMouseVisible = true;
        }

        /// <summary>
        /// 
        /// </summary>
        protected override void Initialize()
        {
            rot = new Vector3(0f, 0f, 0f);

            base.Initialize();
        }

        /// <summary>
        /// CONTENTǍ
        /// </summary>
        protected override void LoadContent()
        {
            spriteBatch = new SpriteBatch(GraphicsDevice);

            box = Content.Load<Model>("box");
        }

        /// <summary>
        /// CONTENTj
        /// </summary>
        protected override void UnloadContent()
        {
            // TODO: Unload any non ContentManager content here
        }

        /// <summary>
        /// XV
        /// </summary>
        /// <param name="gameTime"></param>
        protected override void Update(GameTime gameTime)
        {
            KeyboardState KeyState = Keyboard.GetState();
            if (KeyState.IsKeyDown(Microsoft.Xna.Framework.Input.Keys.Escape)) Exit();

            // f̍W
            pos = UpdatePos(gameTime, pos);

            // f̉]
            rot = UpdateRot(gameTime, rot); 
            
            base.Update(gameTime);
        }

        /// <summary>
        /// `揈
        /// </summary>
        /// <param name="gameTime">`^C~O</param>
        protected override void Draw(GameTime gameTime)
        {
            formMgr.Draw(gameTime);
            graphics.GraphicsDevice.Clear(Color.CornflowerBlue);

            // f̕`
            DrawModel(box, pos, rot); 
            
            base.Draw(gameTime);
        }


        /// <summary>
        /// Ԍo߂Ńf̊pxXV
        /// </summary>
        private Vector3 UpdateRot(GameTime gameTime, Vector3 r)
        {
            Vector2 rotation = MoveInCircle(gameTime, 1f);
            r.X = rotation.X * 5f;
            r.Y = rotation.Y * 5f;
            return r;
        }


        /// <summary>
        /// ~`悤ɍWXV
        /// </summary>
        /// <param name="gameTime">Q[</param>
        /// <param name="p">ʒu</param>
        /// <returns></returns>
        private Vector3 UpdatePos(GameTime gameTime, Vector3 p)
        {
            Vector2 position = MoveInCircle(gameTime, 1f);
            p.X = position.X * 100f;
            p.Y = position.Y * 100f;
            return p;
        }


        /// <summary>
        /// oߎԂɂĕω~̍WԂ
        /// </summary>
        /// <param name="gameTime">Q[</param>
        /// <param name="speed">x</param>
        /// <returns></returns>
        static Vector2 MoveInCircle(GameTime gameTime, float speed)
        {
            double time = gameTime.TotalGameTime.TotalSeconds * speed;

            float x = (float)Math.Cos(time);
            float y = (float)Math.Sin(time);

            return new Vector2(x, y);
        }

        /// <summary>
        /// f̕`
        /// </summary>
        /// <param name="m">f</param>
        /// <param name="p">ʒu</param>
        /// <param name="r">px</param>
        private void DrawModel(Model m, Vector3 p, Vector3 r)
        {
            Matrix[] transforms = new Matrix[m.Bones.Count];
            m.CopyAbsoluteBoneTransformsTo(transforms);

            // AXyNg̎擾
            float aspectRatio = graphics.GraphicsDevice.Viewport.Width / graphics.GraphicsDevice.Viewport.Height;

            // ˉeϊs
            Matrix projection = Matrix.CreatePerspectiveFieldOfView(MathHelper.ToRadians(45.0f),
                aspectRatio, 1.0f, 10000.0f);

            // r[ϊs
            Matrix view = Matrix.CreateLookAt(new Vector3(0.0f, 0.0f, 500.0f), Vector3.Zero, Vector3.Up);

            // bV̕`
            foreach (ModelMesh mesh in m.Meshes)
            {
                foreach (BasicEffect effect in mesh.Effects)
                {
                    effect.EnableDefaultLighting();

                    effect.View = view;
                    effect.Projection = projection;
                    effect.World = transforms[mesh.ParentBone.Index] * Matrix.CreateRotationX(r.X) *
                        Matrix.CreateRotationY(r.Y) * Matrix.CreateRotationZ(r.Z) * Matrix.CreateTranslation(p);
                }
                mesh.Draw();
            }
        }
    }
}
