using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace XnaChatSample.UI
{
    public partial class ChatForm : Form
    {
        private string name = String.Empty;

        public ChatForm()
        {
            InitializeComponent();
            AcceptButton = btnSend;
        }

        private void netCtrl_OnReceive(object sender, NetworkControl.ReceiveEventArgs e)
        {
            txtLog.Text += e.Text;
        }

        private void btnSend_Click(object sender, EventArgs e)
        {
            string code = "0001";
            if (name.Length == 0)
            {
                code = "0000";
                name = txtMessage.Text;
            }
            netCtrl.Send(code + txtMessage.Text);
            txtMessage.Clear();
        }

        private void txtMessage_TextChanged(object sender, EventArgs e)
        {
            if (txtMessage.Text.Length > 0)
            {
                btnSend.Enabled = true;
            }
            else
            {
                btnSend.Enabled = false;
            }
        }

        private void chkScreenMode_CheckedChanged(object sender, EventArgs e)
        {
            CheckBox chkBox = (CheckBox)sender;
            if (chkBox.Checked)
            {
                this.FormBorderStyle = FormBorderStyle.None;
                this.WindowState = FormWindowState.Maximized;
            }
            else
            {
                this.WindowState = FormWindowState.Normal;
                this.FormBorderStyle = FormBorderStyle.FixedToolWindow;
            }
        }
    }
}