using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

using XnaChatSample.Compornent;

namespace XnaChatSample.UI
{
    class FormManager
    {
        GraphicsDeviceManager graphics;
        FpsCalculator fps = null;

        Form xnaForm = null;
        ChatForm winForm = null;

        public FormManager(Game game, GraphicsDeviceManager graphics)
        {
            this.graphics = graphics;

            // R|[lg̓o^
            fps = new FpsCalculator(game);
            game.Components.Add(fps);

            // EChE[hŋN
            winForm = new ChatForm();
            xnaForm = Form.FromHandle(game.Window.Handle) as Form;
            xnaForm.FormBorderStyle = FormBorderStyle.None;
            xnaForm.Dock = DockStyle.Fill;
            xnaForm.TopLevel = false;
            xnaForm.Parent = winForm;
            xnaForm.Visible = true;

            winForm.Controls.Add(xnaForm);
            winForm.Show();

            fps.FpsUpdated += new FpsCalculator.FpsDelegate(fps_FpsUpdated);
        }

        /// <summary>
        /// Form̃^CgFPS\
        /// </summary>
        /// <param name="sender">FpsCalculator</param>
        /// <param name="fps">FPS</param>
        void fps_FpsUpdated(FpsCalculator sender, int fps)
        {
            winForm.Text = "FPS : " + fps;
        }

        /// <summary>
        /// `揈
        /// </summary>
        /// <param name="gameTime"></param>
        public void Draw(GameTime gameTime)
        {
            fps.Draw(gameTime);
        }
    }
}
