using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Net.Sockets;
using System.Windows.Forms;

namespace XnaChatSample.UI
{
    class NetworkControl : Control, IDisposable
    {
        public class StateObject
        {
            // Client socket.
            public Socket socket = null;
            // Size of receive buffer.
            public const int BufferSize = 128 * 1024;
            // Receive buffer.
            public byte[] buffer = new byte[BufferSize];
        }

        // ڑ
        private bool isConnect = false;

        public bool IsConnect
        {
            get { return isConnect; }
            set { isConnect = value; }
        }
	
        // zXgiIPAhXj
        private string host = "localhost";
        
        public string Host
        {
            get { return host; }
            set { host = value; }
        }
	
        // PORTԍ
        private int port = 8002;

        public int Port
        {
            get { return port; }
            set { port = value; }
        }

        // \Pbg
        private TcpClient client = null;
        private StreamWriter writer = null;
        private NetworkStream stream = null;

        public NetworkControl()
        {
            try
            {
                client = new TcpClient();
                client.ReceiveBufferSize = StateObject.BufferSize;
                client.Connect(host, port);
                client.SendBufferSize = StateObject.BufferSize;
                stream = client.GetStream();
                writer = new StreamWriter(stream);
                BeginReceive(client);
            }
            catch (Exception e)
            {
                Console.WriteLine(e);
            }
        }

        protected override void  Dispose(bool disposing)
        {
            if (client != null && client.Connected){
                client.Close();
            }
            base.Dispose(disposing);
        }

        public void Send(string msg)
        {
            if (client != null && client.Connected)
            {
                writer.WriteLine(msg);
                writer.Flush();
            }
        }

        /// <summary>
        /// bZ[WM
        /// </summary>
        /// <param name="tcp"></param>
        private void BeginReceive(TcpClient tcp)
        {
            StateObject state = new StateObject();
            state.socket = tcp.Client;
            state.socket.BeginReceive(state.buffer, 0, StateObject.BufferSize,
                SocketFlags.None, new AsyncCallback(ReceiveCallback), state);
        }

        /// <summary>
        /// BeginReceivẽR[obN
        /// </summary>
        /// <param name="ar"></param>
        private void ReceiveCallback(System.IAsyncResult ar)
        {
            //ԃIuWFNg̎擾
            StateObject state = (StateObject)ar.AsyncState;
            if (!state.socket.Connected) return;
            try {
                int len = state.socket.EndReceive(ar);
                if (len == -1) {
                    state.socket.Close();
                    return;
                }
                string data = Encoding.UTF8.GetString(state.buffer, 0, len);
                if (OnReceive != null) {
                    this.Invoke(new MethodInvoker(delegate{
                        OnReceive(this, new ReceiveEventArgs(this, data));
                    }));
                }
                state.socket.BeginReceive(state.buffer, 0, StateObject.BufferSize,
                    SocketFlags.None, new AsyncCallback(ReceiveCallback), state);

            } catch (SocketException e) {
                Console.WriteLine("T[o[Ƃ̒ʐM؂܂");
                Console.WriteLine(e.ToString());
                state.socket.Close();
            }
        }

        public delegate void ReceiveEventHandler(Object sender, ReceiveEventArgs e);

        public event ReceiveEventHandler OnReceive;

        /// <summary>
        /// bZ[WMEventArgs
        /// </summary>
        /// <param name="sender">Network</param>
        /// <param name="e">Message</param>
        public class ReceiveEventArgs : EventArgs
        {
            private string text;

            public string Text
            {
                get { return text; }
            }

            public ReceiveEventArgs(object sender, string text)
            {
                this.text = text;
            }
        }
    }
}
