import java.io.*;
import java.net.*;

public class TCPServer implements Runnable
{
	public static final int BUFFER_SIZE = 64 * 1024; //64kb
	public static final int TIMEOUT     = 60 * 1000; //60sec
	public static final String ENCODING = "UTF-8";
	ServerSocket serverSocket;
	
	private static int port = 8002;
	
	// ݽ׸
	public TCPServer(int port) throws IOException {
		this.serverSocket = new ServerSocket(port);
		serverSocket.setReceiveBufferSize(BUFFER_SIZE);
	}
	
	public void run() {
		System.out.println("Server start port:" + port);
		while(true) {
			try {
				Socket socket = serverSocket.accept();
				socket.setSendBufferSize(BUFFER_SIZE);
				//socket.setSoTimeout(TIMEOUT);
				new Thread(new ConnectionHandler(socket)).start();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public static void main(String[] args) {
		try {
			TCPServer server = new TCPServer(port);
			server.run();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
